using System;
using System.Xml;
namespace Stubgen
{
	public class Driver
	{
		public static void Usage(String msg)
		{
			Console.WriteLine("StubGen -o outfile assembly");
			Console.WriteLine(msg);
		}

		public static void ParseArgs(String[] args,Options options)
		{
			int len=args.Length;
			for(int i=0;i<len;i++)
			{
				switch(args[i])
				{
					case "-o":
					case "--output":
					{
						if(i!=len-1)
						{
							if(options.outfile!=null) Usage("Cannot have more than one output file");
							options.outfile=args[i+1];
							i=i+1;
						}
						else
						{
							Usage("missing output file");
							return;
						}
					}
					break;

					case "--":
					{
						i++;
						while(i < len)
						{
							options.AddFile(args[i++]);
						}
					}
					break;
					
					default:
					{
						if(args[i].StartsWith("-f"))
						{
							options.Add(args[i].Substring(2));
						}
						else
						{
							options.AddFile(args[i]);
						}
					}
					break;
				}
			}
		}

		public static void Main(String []args)
		{
			if(args.Length==0)
			{
				Usage("Not enough arguments");
			}
			Options options=new Options();
			ParseArgs(args,options);
			TreeGen tree=new TreeGen(options);
			tree.WritePreamble();
			foreach(String name in options.files)
			{
				tree.Generate(name);
			}
			tree.WritePostamble();
			options.Out.Close();
		}
	}
}
